

; 

; 
    include \masm32\include\masm32rt.inc
; 

.686
.mmx
.xmm
comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    sinsi_ex    PROTO
    NightWare   PROTO
    hutch_ex2   PROTO :DWORD,:DWORD
    _qword      PROTO 

    EXTERNDEF bintable:DWORD

    BIN$ MACRO dwArg:REQ, tgt:=<0>
      cc INSTR <dwArg>, <eax>       ;; to avoid a mov eax, eax
      if cc eq 0
        mov eax, dwArg              ;; eax passes value to translate
      endif
      if tgt
        mov edx, tgt                ;; dest buffer - if 0, use Dw2BinBuffer
      else
        mov edx, offset Dw2BinBuffer
      endif
      call Dword2Bin
      EXITM <edx>
    ENDM

    .code






start:
   
; 

    call main
    inkey
    exit

; 

    lcnt equ <50000000>
    binnum equ <1234567890>

main proc

    LOCAL buf1[64]:BYTE
    LOCAL buf2[64]:BYTE
    LOCAL ptr1  :DWORD
    LOCAL ptr2  :DWORD
    LOCAL tot1  :DWORD
    LOCAL tot2  :DWORD
    LOCAL tot3  :DWORD
    LOCAL tot4  :DWORD
    LOCAL tot5  :DWORD

  
    mov ptr1, ptr$(buf1)
    mov ptr2, ptr$(buf2)

    mov tot1, 0
    mov tot2, 0
    mov tot3, 0
    mov tot4, 0
    mov tot5, 0

    mov ecx, binnum
    mov edx, ptr1
    call sinsi_ex

    print ptr1," sinsi_ex",13,10

    ;;; invoke NightWare,binnum,ptr1

    mov eax, binnum
    mov edx, ptr1
    call NightWare

    print ptr1," NightWare",13,10

    invoke hutch_ex2,binnum,ptr1
    print ptr1," hutch_ex2",13,10

    mov ptr1, BIN$(binnum)
    print ptr1," JJ BIN$",13,10

    mov edx,binnum
    mov ecx,ptr1
    invoke _qword
    print ptr1," _qword",13,10,13,10



    invoke SetPriorityClass,rv(GetCurrentProcess),HIGH_PRIORITY_CLASS

    push esi

    invoke SleepEx,200,0

    REPEAT 8

  ; =====================================

    invoke GetTickCount
    push eax

    mov esi, lcnt
    align 16
  @@:
    mov eax, binnum
    mov edx, ptr1
    call NightWare
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add tot1, eax
    print str$(eax)," NightWare",13,10

    invoke SleepEx,100,0

  ; =====================================

    invoke GetTickCount
    push eax

    mov esi, lcnt
    align 16
  @@:
    mov ecx, binnum
    mov edx, ptr1
    call sinsi_ex

    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add tot2, eax
    print str$(eax)," sinsi_ex",13,10

    invoke SleepEx,100,0

  ; =====================================

    invoke GetTickCount
    push eax

    mov esi, lcnt
    align 16
  @@:
    invoke hutch_ex2,binnum,ptr1
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add tot3, eax
    print str$(eax)," hutch_ex2",13,10

    invoke SleepEx,100,0

  ; =====================================

    invoke GetTickCount
    push eax

    mov esi, lcnt
    align 16
  @@:
    mov ptr1, BIN$(binnum)
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add tot4, eax
    print str$(eax)," JJ BIN$",13,10

    invoke SleepEx,100,0

  ; =====================================

    invoke GetTickCount
    push eax



    mov esi, lcnt
    align 16
  @@:
    mov edx,binnum
    mov ecx,ptr1
    invoke _qword
    sub esi, 1
    jnz @B

    invoke GetTickCount
    pop ecx
    sub eax, ecx
    add tot5, eax
    print str$(eax),"  _qword",13,10

    invoke SleepEx,100,0




  ; =====================================

    ENDM

    invoke SetPriorityClass,rv(GetCurrentProcess),NORMAL_PRIORITY_CLASS

    shr tot1, 3
    shr tot2, 3
    shr tot3, 3
    shr tot4, 3
    shr tot5, 3


    print chr$(13,10),"NightWare timing average = "
    print str$(tot1),13,10

    print "sinsi_ex  timing average = "
    print str$(tot2),13,10

    print "hutch_ex2 timing average = "
    print str$(tot3),13,10

    print "JJ BIN$   timing average = "
    print str$(tot4),13,10

    print "mqword   timing average = "
    print str$(tot5),13,10


    pop esi

    ret

main endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

    align 16

  ; ---------------------------------------------
  ; Modified NightWare's DWORD to bin string algo
  ; ---------------------------------------------

NightWare PROC

    .data
      align 16
      BinaryTable DWORD "0000","1000","0100","1100","0010","1010","0110","1110"
                  DWORD "0001","1001","0101","1101","0011","1011","0111","1111"
    .code

    push esi
    push edi

    mov BYTE PTR [edx+32], 0
    mov ecx, 32

    mov esi, eax
    and esi, 00000000Fh
    shr eax, 4
    mov esi, DWORD PTR [BinaryTable+esi*4]
    mov DWORD PTR [edx+ecx-4], esi

    mov esi, eax
    and esi, 00000000Fh
    shr eax, 4
    mov esi, DWORD PTR [BinaryTable+esi*4]
    mov DWORD PTR [edx+ecx-8], esi

    mov esi, eax
    and esi, 00000000Fh
    shr eax, 4
    mov esi, DWORD PTR [BinaryTable+esi*4]
    mov DWORD PTR [edx+ecx-12], esi

    mov esi, eax
    and esi, 00000000Fh
    shr eax, 4
    mov esi, DWORD PTR [BinaryTable+esi*4]
    mov DWORD PTR [edx+ecx-16], esi

    mov esi, eax
    and esi, 00000000Fh
    shr eax, 4
    mov esi, DWORD PTR [BinaryTable+esi*4]
    mov DWORD PTR [edx+ecx-20], esi

    mov esi, eax
    and esi, 00000000Fh
    shr eax, 4
    mov esi, DWORD PTR [BinaryTable+esi*4]
    mov DWORD PTR [edx+ecx-24], esi

    mov esi, eax
    and esi, 00000000Fh
    shr eax, 4
    mov esi, DWORD PTR [BinaryTable+esi*4]
    mov DWORD PTR [edx+ecx-28], esi

    mov esi, eax
    and esi, 00000000Fh
    shr eax, 4
    mov esi, DWORD PTR [BinaryTable+esi*4]
    mov DWORD PTR [edx+ecx-32], esi

    pop edi
    pop esi

    ret ;;; 8

NightWare ENDP

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16

hutch_ex2 proc var:DWORD,buffer:DWORD

    push ebx

    mov ebx, OFFSET bintable
    mov edx, [esp+12]

    movzx eax, BYTE PTR [esp+8][3]
    mov ecx, [ebx+eax*8]
    mov [edx], ecx
    mov ecx, [ebx+eax*8+4]
    mov [edx+4], ecx

    movzx eax, BYTE PTR [esp+8][2]
    mov ecx, [ebx+eax*8]
    mov [edx+8], ecx
    mov ecx, [ebx+eax*8+4]
    mov [edx+12], ecx

    movzx eax, BYTE PTR [esp+8][1]
    mov ecx, [ebx+eax*8]
    mov [edx+16], ecx
    mov ecx, [ebx+eax*8+4]
    mov [edx+20], ecx

    movzx eax, BYTE PTR [esp+8]
    mov ecx, [ebx+eax*8]
    mov [edx+24], ecx
    mov ecx, [ebx+eax*8+4]
    mov [edx+28], ecx

    mov BYTE PTR [edx+32], 0

    pop ebx

    ret 8

hutch_ex2 endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16

sinsi_ex proc               ;;; var:DWORD,buffer:DWORD

  ; var    is passed in ECX
  ; buffer is passed in EDX

    push ebx
    push esi
    movzx esi,cl
    push edi

    mov edi,offset bintable

    mov ebx,[edi+esi*8]
    mov eax,[edi+esi*8+4]
      movzx esi,ch
    mov 24[edx],ebx
    mov 28[edx],eax

    mov ebx,[edi+esi*8]
    mov eax,[edi+esi*8+4]
      shr ecx,16
      movzx esi,cl
    mov 16[edx],ebx
    mov 20[edx],eax

    mov ebx,[edi+esi*8]
    mov eax,[edi+esi*8+4]
      movzx esi,ch
      mov BYTE PTR 32[edx], 0
    mov 8[edx],ebx
    mov 12[edx],eax

    mov ecx,[edi+esi*8]
    mov eax,[edi+esi*8+4]
      pop edi
      pop esi
      pop ebx
    mov [edx],ecx
    mov 4[edx],eax

    ret ; 8

sinsi_ex endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

    align 16

Dword2Bin proc

    .data?
      Dw2BinBuffer dd 9 dup (?)     ; 32 are needed, we pad 4 for alignment
      Dw2BinTable dd 2048/4 dup (?) ; former bintable now in .data? section
    .code

    push ebx
    push esi
    push edi

    mov edi, offset Dw2BinTable     ; old \masm32\m32lib\bintbl.asm
    mov ecx, [edi]
  .if ecx==0                        ; seems you have to initialise your bintable...
    push eax                        ; save value
    push edx                        ; save destination
    mov edx, offset Dw2BinTable+2048 ; destination bintable
    mov esi, 63                     ; outer loop counter
    mov edi, 0FCFDFEFFh             ; seed for creating table
  btInit:
    mov eax, edi
    sub edi, 04040404h
    mov ecx, 31                     ; inner loop counter

    @@: xor ebx, ebx
    dec edx                         ; on exit, edx will point to the string
    sar eax, 1                      ; we work from right to left
    adc ebx, 48                     ; +48: Ascii 0 or, with carry, +49 : Ascii 1
    mov [edx], bl
    dec ecx                         ; decrement inner counter
    jge @B                          ; dec sets only the sign flag

    dec esi                         ; decrement outer counter
    jge btInit                      ; dec sets only the sign flag
    mov edi, edx
    pop edx                         ; get destination
    pop eax                         ; get value
  .endif

  movzx ecx,  al ; the value to translate
  mov ebx, [edi+ecx*8]
  mov esi, [edi+ecx*8+4]
  mov 24[edx], ebx
  mov 28[edx], esi

  movzx ecx,  ah
  mov ebx, [edi+ecx*8]
  mov esi, [edi+ecx*8+4]
  shr eax, 16
  mov 16[edx], ebx
  mov 20[edx], esi

  movzx ecx,  al
  mov ebx, [edi+ecx*8]
  mov esi, [edi+ecx*8+4]
  mov 8[edx], ebx
  mov 12[edx], esi

  movzx ecx,  ah
  mov ebx, [edi+ecx*8]
  mov esi, [edi+ecx*8+4]
  mov [edx], ebx
  mov 4[edx], esi
  mov 32[edx], ch ; null terminator

  pop edi
  pop esi
  pop ebx

  ret

Dword2Bin endp


; 


OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

align 16

_qword proc ;var:DWORD,buffer:DWORD
   ;var in edx
   ;buffer in ecx

    .data
        align 16
        shufmsk     db  8 dup (1)
                    db  8 dup (0)
        bitmsk      db  128,64,32,16,8,4,2,1
                    db  128,64,32,16,8,4,2,1
        ascmsk      db  16 dup (31h)

    .code
 
    movdqa xmm3,OWORD ptr [shufmsk]
    movdqa xmm4,OWORD ptr [bitmsk]
    movdqa xmm5,OWORD ptr [ascmsk]

    pinsrw xmm0,edx,0
    shr edx,16
    pxor xmm2,xmm2
    pinsrw xmm1,edx,0

    pshufb xmm1,xmm3
    pand xmm1,xmm4 
    pcmpeqb xmm1,xmm2
    paddsb xmm1,xmm5
    movdqu OWORD ptr [ecx],xmm1

    align 8
    pshufb xmm0,xmm3
    pand xmm0,xmm4   
    pcmpeqb xmm0,xmm2
    paddsb xmm0,xmm5
    movdqu OWORD ptr [ecx+16],xmm0

    mov BYTE ptr [ecx+32],0

    ret
_qword endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 



; 

end start


















